git-submodule.sh 17.0 KB
Newer Older
L
Lars Hjemli 已提交
1 2
#!/bin/sh
#
3
# git-submodules.sh: add, init, update or list git submodules
L
Lars Hjemli 已提交
4 5 6
#
# Copyright (c) 2007 Lars Hjemli

7
dashless=$(basename "$0" | sed -e 's/-/ /')
8
USAGE="[--quiet] add [-b branch] [--reference <repository>] [--] <repository> [<path>]
9
   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10
   or: $dashless [--quiet] init [--] [<path>...]
11
   or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12
   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13
   or: $dashless [--quiet] foreach [--recursive] <command>
14
   or: $dashless [--quiet] sync [--] [<path>...]"
15
OPTIONS_SPEC=
L
Lars Hjemli 已提交
16
. git-sh-setup
17
. git-parse-remote
L
Lars Hjemli 已提交
18 19
require_work_tree

20
command=
21
branch=
22
reference=
L
Lars Hjemli 已提交
23
cached=
24
files=
25
nofetch=
26
update=
27
prefix=
L
Lars Hjemli 已提交
28

29 30 31
# Resolve relative url by appending to parent's url
resolve_relative_url ()
{
32
	remote=$(get_default_remote)
33 34
	remoteurl=$(git config "remote.$remote.url") ||
		die "remote ($remote) does not have a url defined in .git/config"
35
	url="$1"
36
	remoteurl=${remoteurl%/}
37 38 39 40 41 42 43 44 45 46 47 48 49 50
	while test -n "$url"
	do
		case "$url" in
		../*)
			url="${url#../}"
			remoteurl="${remoteurl%/*}"
			;;
		./*)
			url="${url#./}"
			;;
		*)
			break;;
		esac
	done
51
	echo "$remoteurl/${url%/}"
52 53
}

54 55 56 57 58 59
#
# Get submodule info for registered submodules
# $@ = path to limit submodule list
#
module_list()
{
60
	git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
61 62
}

63 64 65 66 67 68 69
#
# Map submodule path to submodule name
#
# $1 = path
#
module_name()
{
70
	# Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
C
Chris Ridd 已提交
71
	re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
72
	name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
73
		sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
74 75 76 77
       test -z "$name" &&
       die "No submodule mapping found in .gitmodules for path '$path'"
       echo "$name"
}
78 79 80 81

#
# Clone a submodule
#
82
# Prior to calling, cmd_update checks that a possibly existing
83
# path is not a git repository.
84
# Likewise, cmd_add checks that path does not exist at all,
85 86
# since it is the location of a new submodule.
#
87 88 89 90
module_clone()
{
	path=$1
	url=$2
91
	reference="$3"
92 93 94 95 96 97 98 99 100

	# If there already is a directory at the submodule path,
	# expect it to be empty (since that is the default checkout
	# action) and try to remove it.
	# Note: if $path is a symlink to a directory the test will
	# succeed but the rmdir will fail. We might want to fix this.
	if test -d "$path"
	then
		rmdir "$path" 2>/dev/null ||
101
		die "Directory '$path' exists, but is neither empty nor a git repository"
102 103 104 105 106
	fi

	test -e "$path" &&
	die "A file already exist at path '$path'"

107 108 109 110 111 112
	if test -n "$reference"
	then
		git-clone "$reference" -n "$url" "$path"
	else
		git-clone -n "$url" "$path"
	fi ||
113
	die "Clone of '$url' into submodule path '$path' failed"
114 115
}

116 117 118
#
# Add a new submodule to the working tree, .gitmodules and the index
#
119
# $@ = repo path
120 121 122
#
# optional branch is stored in global branch variable
#
123
cmd_add()
124
{
125 126 127 128 129 130 131 132 133 134
	# parse $args after "submodule ... add".
	while test $# -ne 0
	do
		case "$1" in
		-b | --branch)
			case "$2" in '') usage ;; esac
			branch=$2
			shift
			;;
		-q|--quiet)
135
			GIT_QUIET=1
136
			;;
137 138 139 140 141 142 143 144 145
		--reference)
			case "$2" in '') usage ;; esac
			reference="--reference=$2"
			shift
			;;
		--reference=*)
			reference="$1"
			shift
			;;
146 147 148 149 150 151 152 153 154 155 156 157 158 159
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

160 161 162
	repo=$1
	path=$2

163 164 165 166 167
	if test -z "$path"; then
		path=$(echo "$repo" |
			sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
	fi

168
	if test -z "$repo" -o -z "$path"; then
169 170 171
		usage
	fi

172 173 174 175 176 177 178 179 180 181 182 183 184 185 186
	# assure repo is absolute or relative to parent
	case "$repo" in
	./*|../*)
		# dereference source url relative to parent's url
		realrepo=$(resolve_relative_url "$repo") || exit
		;;
	*:*|/*)
		# absolute url
		realrepo=$repo
		;;
	*)
		die "repo URL: '$repo' must be absolute or begin with ./|../"
	;;
	esac

187 188 189 190 191 192 193 194 195 196 197 198
	# normalize path:
	# multiple //; leading ./; /./; /../; trailing /
	path=$(printf '%s/\n' "$path" |
		sed -e '
			s|//*|/|g
			s|^\(\./\)*||
			s|/\./|/|g
			:start
			s|\([^/]*\)/\.\./||
			tstart
			s|/*$||
		')
199
	git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
200 201
	die "'$path' already exists in the index"

202 203 204
	# perhaps the path exists and is already a git repo, else clone it
	if test -e "$path"
	then
205
		if test -d "$path"/.git -o -f "$path"/.git
206 207 208 209 210
		then
			echo "Adding existing repo at '$path' to the index"
		else
			die "'$path' already exists and is not a valid git repo"
		fi
211 212 213 214 215 216 217 218 219 220

		case "$repo" in
		./*|../*)
			url=$(resolve_relative_url "$repo") || exit
		    ;;
		*)
			url="$repo"
			;;
		esac
		git config submodule."$path".url "$url"
221 222
	else

223
		module_clone "$path" "$realrepo" "$reference" || exit
224 225 226 227 228 229 230 231 232
		(
			unset GIT_DIR
			cd "$path" &&
			# ash fails to wordsplit ${branch:+-b "$branch"...}
			case "$branch" in
			'') git checkout -f -q ;;
			?*) git checkout -f -q -b "$branch" "origin/$branch" ;;
			esac
		) || die "Unable to checkout submodule '$path'"
233 234
	fi

235 236 237
	git add "$path" ||
	die "Failed to add submodule '$path'"

238 239
	git config -f .gitmodules submodule."$path".path "$path" &&
	git config -f .gitmodules submodule."$path".url "$repo" &&
240 241 242 243
	git add .gitmodules ||
	die "Failed to register submodule '$path'"
}

244 245 246 247 248 249 250 251
#
# Execute an arbitrary command sequence in each checked out
# submodule
#
# $@ = command to execute
#
cmd_foreach()
{
252 253 254 255 256 257 258
	# parse $args after "submodule ... foreach".
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
			GIT_QUIET=1
			;;
259 260 261
		--recursive)
			recursive=1
			;;
262 263 264 265 266 267 268 269 270 271
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

272
	module_list |
273 274 275 276
	while read mode sha1 stage path
	do
		if test -e "$path"/.git
		then
277
			say "Entering '$prefix$path'"
278
			name=$(module_name "$path")
279 280 281 282 283 284 285 286 287 288
			(
				prefix="$prefix$path/"
				unset GIT_DIR
				cd "$path" &&
				eval "$@" &&
				if test -n "$recursive"
				then
					cmd_foreach "--recursive" "$@"
				fi
			) ||
289 290 291 292 293
			die "Stopping at '$path'; script returned non-zero status."
		fi
	done
}

L
Lars Hjemli 已提交
294
#
295
# Register submodules in .git/config
L
Lars Hjemli 已提交
296 297 298
#
# $@ = requested paths (default to all)
#
299
cmd_init()
L
Lars Hjemli 已提交
300
{
301 302 303 304 305
	# parse $args after "submodule ... init".
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
306
			GIT_QUIET=1
307 308 309 310 311 312 313 314 315 316 317 318 319 320 321
			;;
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

322
	module_list "$@" |
L
Lars Hjemli 已提交
323 324
	while read mode sha1 stage path
	do
325
		# Skip already registered paths
326
		name=$(module_name "$path") || exit
327
		url=$(git config submodule."$name".url)
328
		test -z "$url" || continue
L
Lars Hjemli 已提交
329

330
		url=$(git config -f .gitmodules submodule."$name".url)
L
Lars Hjemli 已提交
331
		test -z "$url" &&
332
		die "No url found for submodule path '$path' in .gitmodules"
L
Lars Hjemli 已提交
333

334 335 336
		# Possibly a url relative to parent
		case "$url" in
		./*|../*)
337
			url=$(resolve_relative_url "$url") || exit
338 339 340
			;;
		esac

341
		git config submodule."$name".url "$url" ||
342
		die "Failed to register url for submodule path '$path'"
L
Lars Hjemli 已提交
343

344 345 346 347
		upd="$(git config -f .gitmodules submodule."$name".update)"
		test -z "$upd" ||
		git config submodule."$name".update "$upd" ||
		die "Failed to register update mode for submodule path '$path'"
348

349
		say "Submodule '$name' ($url) registered for path '$path'"
L
Lars Hjemli 已提交
350 351 352 353
	done
}

#
354
# Update each submodule path to correct revision, using clone and checkout as needed
L
Lars Hjemli 已提交
355 356 357
#
# $@ = requested paths (default to all)
#
358
cmd_update()
L
Lars Hjemli 已提交
359
{
360
	# parse $args after "submodule ... update".
361
	orig_args="$@"
362 363 364 365
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
366
			shift
367
			GIT_QUIET=1
368
			;;
369
		-i|--init)
370
			init=1
371 372
			shift
			;;
373 374 375 376
		-N|--no-fetch)
			shift
			nofetch=1
			;;
377 378
		-r|--rebase)
			shift
379
			update="rebase"
380
			;;
381 382 383 384 385 386 387 388 389
		--reference)
			case "$2" in '') usage ;; esac
			reference="--reference=$2"
			shift 2
			;;
		--reference=*)
			reference="$1"
			shift
			;;
390 391 392 393
		-m|--merge)
			shift
			update="merge"
			;;
394 395 396 397
		--recursive)
			shift
			recursive=1
			;;
398 399 400 401 402 403 404 405 406 407 408 409 410
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
	done

411 412 413 414 415
	if test -n "$init"
	then
		cmd_init "--" "$@" || return
	fi

416
	module_list "$@" |
L
Lars Hjemli 已提交
417 418
	while read mode sha1 stage path
	do
419
		name=$(module_name "$path") || exit
420
		url=$(git config submodule."$name".url)
421
		update_module=$(git config submodule."$name".update)
422
		if test -z "$url"
L
Lars Hjemli 已提交
423 424 425 426
		then
			# Only mention uninitialized submodules when its
			# path have been specified
			test "$#" != "0" &&
427
			say "Submodule path '$path' not initialized" &&
428
			say "Maybe you want to use 'update --init'?"
429 430 431
			continue
		fi

432
		if ! test -d "$path"/.git -o -f "$path"/.git
433
		then
434
			module_clone "$path" "$url" "$reference"|| exit
435 436
			subsha1=
		else
437
			subsha1=$(unset GIT_DIR; cd "$path" &&
438
				git rev-parse --verify HEAD) ||
439
			die "Unable to find current revision in submodule path '$path'"
L
Lars Hjemli 已提交
440
		fi
441

442
		if ! test -z "$update"
443
		then
444
			update_module=$update
445 446
		fi

L
Lars Hjemli 已提交
447 448
		if test "$subsha1" != "$sha1"
		then
449 450 451 452 453
			force=
			if test -z "$subsha1"
			then
				force="-f"
			fi
454 455 456 457 458 459 460 461

			if test -z "$nofetch"
			then
				(unset GIT_DIR; cd "$path" &&
					git-fetch) ||
				die "Unable to fetch in submodule path '$path'"
			fi

462 463 464
			case "$update_module" in
			rebase)
				command="git rebase"
465 466
				action="rebase"
				msg="rebased onto"
467
				;;
468 469 470 471 472
			merge)
				command="git merge"
				action="merge"
				msg="merged in"
				;;
473 474
			*)
				command="git checkout $force -q"
475 476
				action="checkout"
				msg="checked out"
477 478
				;;
			esac
L
Lars Hjemli 已提交
479

480 481 482
			(unset GIT_DIR; cd "$path" && $command "$sha1") ||
			die "Unable to $action '$sha1' in submodule path '$path'"
			say "Submodule path '$path': $msg '$sha1'"
L
Lars Hjemli 已提交
483
		fi
484 485 486 487 488 489

		if test -n "$recursive"
		then
			(unset GIT_DIR; cd "$path" && cmd_update $orig_args) ||
			die "Failed to recurse into submodule path '$path'"
		fi
L
Lars Hjemli 已提交
490 491 492
	done
}

493 494
set_name_rev () {
	revname=$( (
495
		unset GIT_DIR
496
		cd "$1" && {
497 498
			git describe "$2" 2>/dev/null ||
			git describe --tags "$2" 2>/dev/null ||
499 500
			git describe --contains "$2" 2>/dev/null ||
			git describe --all --always "$2"
501 502 503 504
		}
	) )
	test -z "$revname" || revname=" ($revname)"
}
P
Ping Yin 已提交
505 506 507 508 509 510 511 512 513
#
# Show commit summary for submodules in index or working tree
#
# If '--cached' is given, show summary between index and given commit,
# or between working tree and given commit
#
# $@ = [commit (default 'HEAD'),] requested paths (default all)
#
cmd_summary() {
514
	summary_limit=-1
515
	for_status=
516
	diff_cmd=diff-index
517

P
Ping Yin 已提交
518 519 520 521 522 523 524
	# parse $args after "submodule ... summary".
	while test $# -ne 0
	do
		case "$1" in
		--cached)
			cached="$1"
			;;
525 526 527
		--files)
			files="$1"
			;;
528 529 530
		--for-status)
			for_status="$1"
			;;
531 532 533 534 535 536 537 538 539
		-n|--summary-limit)
			if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
			then
				:
			else
				usage
			fi
			shift
			;;
P
Ping Yin 已提交
540 541 542 543 544 545 546 547 548 549 550 551 552
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done
553

554 555
	test $summary_limit = 0 && return

M
Miklos Vajna 已提交
556
	if rev=$(git rev-parse -q --verify "$1^0")
P
Ping Yin 已提交
557 558 559 560 561 562 563
	then
		head=$rev
		shift
	else
		head=HEAD
	fi

564 565 566 567 568 569 570 571
	if [ -n "$files" ]
	then
		test -n "$cached" &&
		die "--cached cannot be used with --files"
		diff_cmd=diff-files
		head=
	fi

P
Ping Yin 已提交
572 573
	cd_to_toplevel
	# Get modified modules cared by user
574
	modules=$(git $diff_cmd $cached --raw $head -- "$@" |
575
		sane_egrep '^:([0-7]* )?160000' |
P
Ping Yin 已提交
576 577 578 579 580 581 582 583 584
		while read mod_src mod_dst sha1_src sha1_dst status name
		do
			# Always show modules deleted or type-changed (blob<->module)
			test $status = D -o $status = T && echo "$name" && continue
			# Also show added or modified modules which are checked out
			GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
			echo "$name"
		done
	)
585

586 587
	test -z "$modules" && return

588
	git $diff_cmd $cached --raw $head -- $modules |
589
	sane_egrep '^:([0-7]* )?160000' |
590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614
	cut -c2- |
	while read mod_src mod_dst sha1_src sha1_dst status name
	do
		if test -z "$cached" &&
			test $sha1_dst = 0000000000000000000000000000000000000000
		then
			case "$mod_dst" in
			160000)
				sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
				;;
			100644 | 100755 | 120000)
				sha1_dst=$(git hash-object $name)
				;;
			000000)
				;; # removed
			*)
				# unexpected type
				echo >&2 "unexpected mode $mod_dst"
				continue ;;
			esac
		fi
		missing_src=
		missing_dst=

		test $mod_src = 160000 &&
M
Miklos Vajna 已提交
615
		! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
616 617 618
		missing_src=t

		test $mod_dst = 160000 &&
M
Miklos Vajna 已提交
619
		! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
620
		missing_dst=t
621

622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647
		total_commits=
		case "$missing_src,$missing_dst" in
		t,)
			errmsg="  Warn: $name doesn't contain commit $sha1_src"
			;;
		,t)
			errmsg="  Warn: $name doesn't contain commit $sha1_dst"
			;;
		t,t)
			errmsg="  Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
			;;
		*)
			errmsg=
			total_commits=$(
			if test $mod_src = 160000 -a $mod_dst = 160000
			then
				range="$sha1_src...$sha1_dst"
			elif test $mod_src = 160000
			then
				range=$sha1_src
			else
				range=$sha1_dst
			fi
			GIT_DIR="$name/.git" \
			git log --pretty=oneline --first-parent $range | wc -l
			)
648
			total_commits=" ($(($total_commits + 0)))"
649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672
			;;
		esac

		sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
		sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
		if test $status = T
		then
			if test $mod_dst = 160000
			then
				echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
			else
				echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
			fi
		else
			echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
		fi
		if test -n "$errmsg"
		then
			# Don't give error msg for modification whose dst is not submodule
			# i.e. deleted or changed to blob
			test $mod_dst = 160000 && echo "$errmsg"
		else
			if test $mod_src = 160000 -a $mod_dst = 160000
			then
673 674
				limit=
				test $summary_limit -gt 0 && limit="-$summary_limit"
675
				GIT_DIR="$name/.git" \
676
				git log $limit --pretty='format:  %m %s' \
677 678 679 680 681 682 683 684 685 686 687 688
				--first-parent $sha1_src...$sha1_dst
			elif test $mod_dst = 160000
			then
				GIT_DIR="$name/.git" \
				git log --pretty='format:  > %s' -1 $sha1_dst
			else
				GIT_DIR="$name/.git" \
				git log --pretty='format:  < %s' -1 $sha1_src
			fi
			echo
		fi
		echo
689 690
	done |
	if test -n "$for_status"; then
691 692 693 694 695
		if [ -n "$files" ]; then
			echo "# Submodules changed but not updated:"
		else
			echo "# Submodule changes to be committed:"
		fi
696 697 698 699 700
		echo "#"
		sed -e 's|^|# |' -e 's|^# $|#|'
	else
		cat
	fi
P
Ping Yin 已提交
701
}
L
Lars Hjemli 已提交
702
#
703
# List all submodules, prefixed with:
L
Lars Hjemli 已提交
704 705 706 707 708 709 710 711
#  - submodule not initialized
#  + different revision checked out
#
# If --cached was specified the revision in the index will be printed
# instead of the currently checked out revision.
#
# $@ = requested paths (default to all)
#
712
cmd_status()
L
Lars Hjemli 已提交
713
{
714
	# parse $args after "submodule ... status".
715
	orig_args="$@"
716 717 718 719
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
720
			GIT_QUIET=1
721 722 723 724
			;;
		--cached)
			cached=1
			;;
725 726 727
		--recursive)
			recursive=1
			;;
728 729 730 731 732 733 734 735 736 737 738 739 740 741
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

742
	module_list "$@" |
L
Lars Hjemli 已提交
743 744
	while read mode sha1 stage path
	do
745
		name=$(module_name "$path") || exit
746
		url=$(git config submodule."$name".url)
747
		displaypath="$prefix$path"
748
		if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
L
Lars Hjemli 已提交
749
		then
750
			say "-$sha1 $displaypath"
L
Lars Hjemli 已提交
751 752
			continue;
		fi
753
		set_name_rev "$path" "$sha1"
L
Lars Hjemli 已提交
754 755
		if git diff-files --quiet -- "$path"
		then
756
			say " $sha1 $displaypath$revname"
L
Lars Hjemli 已提交
757 758 759
		else
			if test -z "$cached"
			then
760
				sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
761
				set_name_rev "$path" "$sha1"
L
Lars Hjemli 已提交
762
			fi
763 764 765 766 767 768 769 770 771 772 773 774
			say "+$sha1 $displaypath$revname"
		fi

		if test -n "$recursive"
		then
			(
				prefix="$displaypath/"
				unset GIT_DIR
				cd "$path" &&
				cmd_status $orig_args
			) ||
			die "Failed to recurse into submodule path '$path'"
L
Lars Hjemli 已提交
775 776 777
		fi
	done
}
778 779 780 781 782 783 784 785 786 787 788
#
# Sync remote urls for submodules
# This makes the value for remote.$remote.url match the value
# specified in .gitmodules.
#
cmd_sync()
{
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
789
			GIT_QUIET=1
790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809
			shift
			;;
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
	done
	cd_to_toplevel
	module_list "$@" |
	while read mode sha1 stage path
	do
		name=$(module_name "$path")
		url=$(git config -f .gitmodules --get submodule."$name".url)
810 811 812 813 814 815 816 817

		# Possibly a url relative to parent
		case "$url" in
		./*|../*)
			url=$(resolve_relative_url "$url") || exit
			;;
		esac

818 819 820 821 822 823 824 825 826 827 828 829
		if test -e "$path"/.git
		then
		(
			unset GIT_DIR
			cd "$path"
			remote=$(get_default_remote)
			say "Synchronizing submodule url for '$name'"
			git config remote."$remote".url "$url"
		)
		fi
	done
}
L
Lars Hjemli 已提交
830

831 832 833 834 835 836 837
# This loop parses the command line arguments to find the
# subcommand name to dispatch.  Parsing of the subcommand specific
# options are primarily done by the subcommand implementations.
# Subcommand specific options such as --branch and --cached are
# parsed here as well, for backward compatibility.

while test $# != 0 && test -z "$command"
L
Lars Hjemli 已提交
838 839
do
	case "$1" in
840
	add | foreach | init | update | status | summary | sync)
841
		command=$1
L
Lars Hjemli 已提交
842 843
		;;
	-q|--quiet)
844
		GIT_QUIET=1
L
Lars Hjemli 已提交
845
		;;
846 847 848 849 850 851 852 853
	-b|--branch)
		case "$2" in
		'')
			usage
			;;
		esac
		branch="$2"; shift
		;;
L
Lars Hjemli 已提交
854
	--cached)
P
Ping Yin 已提交
855
		cached="$1"
L
Lars Hjemli 已提交
856 857 858 859 860 861 862 863 864 865 866 867 868 869
		;;
	--)
		break
		;;
	-*)
		usage
		;;
	*)
		break
		;;
	esac
	shift
done

870 871 872 873 874 875
# No command word defaults to "status"
test -n "$command" || command=status

# "-b branch" is accepted only by "add"
if test -n "$branch" && test "$command" != add
then
876
	usage
877 878
fi

P
Ping Yin 已提交
879 880
# "--cached" is accepted only by "status" and "summary"
if test -n "$cached" && test "$command" != status -a "$command" != summary
881
then
L
Lars Hjemli 已提交
882
	usage
883 884 885
fi

"cmd_$command" "$@"